# Written by Il-Chul Yoon <iyoon@cs.umd.edu>

package clientd;

use util::Debug;
use SOAP::Transport::HTTP;
use FrontHandler;
use strict;

# Set client information
my $client_host = $ENV{HPCALE_CLIENT_HOST};
my $client_port = $ENV{HPCALE_CLIENT_PORT};

# handle Broken pipe' or Ctrl-C
$SIG{INT} = \&sigint_handler;
$SIG{PIPE} = \&sigpipe_handler;

my $mod = "Client-SOAP-Daemon";
my $pipe= "$ENV{HPCALE_CLIENT_LOGPATH}/$ENV{HPCALE_CLIENT_LOGFILE}";
my $daemon = undef;

sub start_daemon 
{
   $daemon = new SOAP::Transport::HTTP::Daemon(
      LocalAddr => $client_host,
      LocalPort => $client_port,
      Reuse => 1
   );

   my $str = "$mod is waiting at ".$daemon->url;
   Debug::logmsg($mod, "STDOUT", $str); 
   Debug::logmsg($mod, $pipe, $str); 

   $daemon->dispatch_to('FrontHandler');
   $daemon->handle;
}

sub sigint_handler 
{
   my $str = "$mod is shutdown";
   Debug::logmsg($mod, "STDOUT", $str);
   Debug::logmsg($mod, $pipe, $str);

   # terminate daemon
   $daemon->close();
}

sub sigpipe_handler 
{
   my $str = "$mod failed to send/recv files.";
   Debug::logmsg($mod, "STDOUT", $str);
   Debug::logmsg($mod, $pipe, $str);

   # terminate daemon
   $daemon->close();
}

1;
